ON_BinaryArchiveBuffer Class Reference

`#include <pcl/surface/3rdparty/opennurbs/opennurbs_archive.h>`

Inheritance diagram for ON_BinaryArchiveBuffer:

## Public Member Functions

| ON_BinaryArchiveBuffer (ON::archive_mode, ON_Buffer *buffer)
virtual | ~ON_BinaryArchiveBuffer ()
bool | SetBuffer (ON_Buffer *buffer)
ON_Buffer * | Buffer () const
size_t | CurrentPosition () const
bool | SeekFromCurrentPosition (int)
bool | SeekFromStart (size_t)
bool | AtEnd () const
bool | SeekFromEnd (ON__INT64)
Public Member Functions inherited from ON_BinaryArchive
| ON_BinaryArchive (ON::archive_mode)
virtual | ~ON_BinaryArchive ()
bool | BigSeekFromStart (ON__UINT64 offset)
bool | BigSeekForward (ON__UINT64 offset)
bool | BigSeekBackward (ON__UINT64 offset)
bool | BigSeekFromCurrentPosition (ON__INT64 offset)
bool | ReadMode () const
bool | WriteMode () const
ON::endian | Endian () const
int | BadCRCCount () const
bool | ReadByte (size_t, void *)
bool | WriteByte (size_t, const void *)
ON__UINT64 | ReadBuffer (ON__UINT64 sizeof_buffer, void *buffer)
bool | EnableCRCCalculation (bool bEnable)
bool | ReadCompressedBufferSize (size_t *sizeof__outbuffer)
bool | ReadCompressedBuffer (size_t sizeof__outbuffer, void *outbuffer, int *bFailedCRC)
bool | WriteCompressedBuffer (size_t sizeof__inbuffer, const void *inbuffer)
bool | ReadBool (bool *)
bool | ReadChar (size_t, char *)
bool | ReadChar (size_t, unsigned char *)
bool | ReadChar (char *)
bool | ReadChar (unsigned char *)
bool | ReadShort (size_t, short *)
bool | ReadShort (size_t, unsigned short *)
bool | ReadShort (short *)
bool | ReadShort (unsigned short *)
bool | ReadInt (size_t, int *)
bool | ReadInt (size_t, unsigned int *)
bool | ReadInt (int *)
bool | ReadInt (unsigned int *)
bool | ReadBigInt (size_t, ON__INT64 *)
bool | ReadBigInt (size_t, ON__UINT64 *)
bool | ReadBigInt (ON__INT64 *)
bool | ReadBigInt (ON__UINT64 *)
bool | ReadLong (size_t, long *)
bool | ReadLong (size_t, unsigned long *)
bool | ReadLong (long *)
bool | ReadLong (unsigned long *)
bool | ReadSize (size_t *)
bool | ReadBigSize (size_t *)
bool | ReadBigTime (time_t *)
bool | ReadFloat (size_t, float *)
bool | ReadFloat (float *)
bool | ReadDouble (size_t, double *)
bool | ReadDouble (double *)
bool | ReadColor (ON_Color &)
bool | ReadPoint (ON_2dPoint &)
bool | ReadPoint (ON_3dPoint &)
bool | ReadPoint (ON_4dPoint &)
bool | ReadVector (ON_2dVector &)
bool | ReadVector (ON_3dVector &)
bool | ReadBoundingBox (ON_BoundingBox &)
bool | ReadXform (ON_Xform &)
bool | ReadPlaneEquation (ON_PlaneEquation &)
bool | ReadPlane (ON_Plane &)
bool | ReadLine (ON_Line &)
bool | ReadArc (ON_Arc &)
bool | ReadCircle (ON_Circle &)
bool | ReadInterval (ON_Interval &)
bool | ReadUuid (ON_UUID &)
bool | ReadDisplayMaterialRef (ON_DisplayMaterialRef &)
bool | ReadLinetypeSegment (ON_LinetypeSegment &)
bool | ReadTime (struct tm &)
ON_DEPRECATED bool | ReadStringSize (size_t *str_array_count)
bool | ReadStringUTF8ElementCount (size_t *string_utf8_element_count)
bool | ReadStringUTF16ElementCount (size_t *string_utf16_element_count)
bool | ReadString (size_t str_array_count, char *str_array)
bool | ReadString (size_t str_array_count, unsigned char *str_array)
bool | ReadString (size_t str_array_count, unsigned short *str_array)
bool | ReadString (ON_String &sUTF8)
bool | ReadString (ON_wString &s)
bool | ReadComponentIndex (ON_COMPONENT_INDEX &)
bool | ReadArray (ON_SimpleArray< bool > &)
bool | ReadArray (ON_SimpleArray< char > &)
bool | ReadArray (ON_SimpleArray< short > &)
bool | ReadArray (ON_SimpleArray< int > &)
bool | ReadArray (ON_SimpleArray< float > &)
bool | ReadArray (ON_SimpleArray< double > &)
bool | ReadArray (ON_SimpleArray< ON_Color > &)
bool | ReadArray (ON_SimpleArray< ON_2dPoint > &)
bool | ReadArray (ON_SimpleArray< ON_3dPoint > &)
bool | ReadArray (ON_SimpleArray< ON_4dPoint > &)
bool | ReadArray (ON_SimpleArray< ON_2dVector > &)
bool | ReadArray (ON_SimpleArray< ON_3dVector > &)
bool | ReadArray (ON_SimpleArray< ON_Xform > &)
bool | ReadArray (ON_SimpleArray< ON_2fPoint > &)
bool | ReadArray (ON_SimpleArray< ON_3fPoint > &)
bool | ReadArray (ON_SimpleArray< ON_4fPoint > &)
bool | ReadArray (ON_SimpleArray< ON_2fVector > &)
bool | ReadArray (ON_SimpleArray< ON_3fVector > &)
bool | ReadArray (ON_SimpleArray< ON_UUID > &)
bool | ReadArray (ON_SimpleArray< ON_UuidIndex > &)
bool | ReadArray (ON_SimpleArray< ON_SurfaceCurvature > &)
bool | ReadArray (ON_ClassArray< ON_String > &)
bool | ReadArray (ON_ClassArray< ON_wString > &)
bool | ReadArray (ON_SimpleArray< ON_DisplayMaterialRef > &)
bool | ReadArray (ON_SimpleArray< ON_LinetypeSegment > &)
bool | ReadArray (ON_SimpleArray< ON_MappingChannel > &)
bool | ReadArray (ON_ClassArray< ON_MaterialRef > &)
bool | ReadArray (ON_ClassArray< ON_MappingRef > &)
bool | ReadArray (ON_ClassArray< class ON_ObjRef > &)
bool | ReadArray (ON_SimpleArray< class ON_ObjRef_IRefID > &)
bool | ReadArray (ON_SimpleArray< class ON_ClippingPlaneInfo > &)
bool | ReadArray (ON_ObjectArray< class ON_Layer > &)
bool | ReadArray (ON_SimpleArray< class ON_Layer *> &)
bool | WriteBool (bool)
bool | WriteChar (size_t, const char *)
bool | WriteChar (size_t, const unsigned char *)
bool | WriteChar (char)
bool | WriteChar (unsigned char)
bool | WriteShort (size_t, const short *)
bool | WriteShort (size_t, const unsigned short *)
bool | WriteShort (short)
bool | WriteShort (unsigned short)
bool | WriteInt (size_t, const int *)
bool | WriteInt (size_t, const unsigned int *)
bool | WriteInt (int)
bool | WriteInt (unsigned int)
bool | WriteBigInt (size_t, const ON__INT64 *)
bool | WriteBigInt (size_t, const ON__UINT64 *)
bool | WriteBigInt (ON__INT64)
bool | WriteBigInt (ON__UINT64)
bool | WriteLong (size_t, const long *)
bool | WriteLong (size_t, const unsigned long *)
bool | WriteLong (long)
bool | WriteLong (unsigned long)
bool | WriteSize (size_t)
bool | WriteBigSize (size_t)
bool | WriteBigTime (time_t)
bool | WriteFloat (size_t, const float *)
bool | WriteFloat (float)
bool | WriteDouble (size_t, const double *)
bool | WriteDouble (double)
bool | WriteColor (const ON_Color &)
bool | WritePoint (const ON_2dPoint &)
bool | WritePoint (const ON_3dPoint &)
bool | WritePoint (const ON_4dPoint &)
bool | WriteVector (const ON_2dVector &)
bool | WriteVector (const ON_3dVector &)
bool | WriteBoundingBox (const ON_BoundingBox &)
bool | WriteXform (const ON_Xform &)
bool | WritePlaneEquation (const ON_PlaneEquation &)
bool | WritePlane (const ON_Plane &)
bool | WriteLine (const ON_Line &)
bool | WriteArc (const ON_Arc &)
bool | WriteCircle (const ON_Circle &)
bool | WriteInterval (const ON_Interval &)
bool | WriteUuid (const ON_UUID &)
bool | WriteDisplayMaterialRef (const ON_DisplayMaterialRef &)
bool | WriteLinetypeSegment (const ON_LinetypeSegment &)
bool | WriteTime (const struct tm &)
bool | WriteString (const char *sUTF8)
bool | WriteString (const unsigned char *sUTF8)
bool | WriteString (const unsigned short *sUTF16)
bool | WriteString (const ON_String &sUTF8)
bool | WriteString (const ON_wString &s)
bool | WriteComponentIndex (const ON_COMPONENT_INDEX &)
bool | WriteArray (const ON_SimpleArray< bool > &)
bool | WriteArray (const ON_SimpleArray< char > &)
bool | WriteArray (const ON_SimpleArray< short > &)
bool | WriteArray (const ON_SimpleArray< int > &)
bool | WriteArray (const ON_SimpleArray< float > &)
bool | WriteArray (const ON_SimpleArray< double > &)
bool | WriteArray (const ON_SimpleArray< ON_Color > &)
bool | WriteArray (const ON_SimpleArray< ON_2dPoint > &)
bool | WriteArray (const ON_SimpleArray< ON_3dPoint > &)
bool | WriteArray (const ON_SimpleArray< ON_4dPoint > &)
bool | WriteArray (const ON_SimpleArray< ON_2dVector > &)
bool | WriteArray (const ON_SimpleArray< ON_3dVector > &)
bool | WriteArray (const ON_SimpleArray< ON_2fPoint > &)
bool | WriteArray (const ON_SimpleArray< ON_3fPoint > &)
bool | WriteArray (const ON_SimpleArray< ON_4fPoint > &)
bool | WriteArray (const ON_SimpleArray< ON_2fVector > &)
bool | WriteArray (const ON_SimpleArray< ON_3fVector > &)
bool | WriteArray (const ON_SimpleArray< ON_Xform > &)
bool | WriteArray (const ON_SimpleArray< ON_UUID > &)
bool | WriteArray (const ON_SimpleArray< ON_UuidIndex > &)
bool | WriteArray (const ON_SimpleArray< ON_SurfaceCurvature > &)
bool | WriteArray (const ON_ClassArray< ON_String > &)
bool | WriteArray (const ON_ClassArray< ON_wString > &)
bool | WriteArray (const ON_SimpleArray< ON_DisplayMaterialRef > &)
bool | WriteArray (const ON_SimpleArray< ON_LinetypeSegment > &)
bool | WriteArray (const ON_SimpleArray< ON_MappingChannel > &)
bool | WriteArray (const ON_ClassArray< ON_MaterialRef > &)
bool | WriteArray (const ON_ClassArray< ON_MappingRef > &)
bool | WriteArray (const ON_ClassArray< class ON_ObjRef > &)
bool | WriteArray (const ON_SimpleArray< class ON_ObjRef_IRefID > &)
bool | WriteArray (const ON_SimpleArray< class ON_ClippingPlaneInfo > &)
bool | WriteArray (int count, const class ON_Layer *)
bool | WriteArray (int count, const class ON_Layer *const *)
int | ReadObject (ON_Object **ppObject)
int | ReadObject (ON_Object &object)
bool | WriteObject (const ON_Object *)
bool | WriteObject (const ON_Object &)
bool | EnableSave3dmRenderMeshes (ON_BOOL32=true)
bool | Save3dmRenderMeshes () const
bool | EnableSave3dmAnalysisMeshes (ON_BOOL32=true)
bool | Save3dmAnalysisMeshes () const
bool | EnableSaveUserData (ON_BOOL32=true)
bool | SaveUserData () const
bool | Write3dmStartSection (int version, const char *sStartSectionComment)
bool | Read3dmStartSection (int *version, ON_String &sStartSectionComment)
bool | Write3dmProperties (const ON_3dmProperties &)
bool | Read3dmProperties (ON_3dmProperties &)
bool | Write3dmSettings (const ON_3dmSettings &)
bool | Read3dmSettings (ON_3dmSettings &)
bool | BeginWrite3dmBitmapTable ()
bool | Write3dmBitmap (const ON_Bitmap &)
bool | EndWrite3dmBitmapTable ()
bool | BeginRead3dmBitmapTable ()
int | Read3dmBitmap (ON_Bitmap **)
bool | EndRead3dmBitmapTable ()
bool | BeginWrite3dmTextureMappingTable ()
bool | Write3dmTextureMapping (const ON_TextureMapping &)
bool | EndWrite3dmTextureMappingTable ()
bool | BeginRead3dmTextureMappingTable ()
int | Read3dmTextureMapping (ON_TextureMapping **)
bool | EndRead3dmTextureMappingTable ()
bool | BeginWrite3dmMaterialTable ()
bool | Write3dmMaterial (const ON_Material &)
bool | EndWrite3dmMaterialTable ()
bool | BeginRead3dmMaterialTable ()
int | Read3dmMaterial (ON_Material **)
bool | EndRead3dmMaterialTable ()
bool | BeginWrite3dmLinetypeTable ()
bool | Write3dmLinetype (const ON_Linetype &)
bool | EndWrite3dmLinetypeTable ()
bool | BeginRead3dmLinetypeTable ()
int | Read3dmLinetype (ON_Linetype **)
bool | EndRead3dmLinetypeTable ()
bool | BeginWrite3dmLayerTable ()
bool | Write3dmLayer (const ON_Layer &)
bool | EndWrite3dmLayerTable ()
bool | BeginRead3dmLayerTable ()
int | Read3dmLayer (ON_Layer **)
bool | EndRead3dmLayerTable ()
bool | BeginWrite3dmGroupTable ()
bool | Write3dmGroup (const ON_Group &)
bool | EndWrite3dmGroupTable ()
bool | BeginRead3dmGroupTable ()
int | Read3dmGroup (ON_Group **)
bool | EndRead3dmGroupTable ()
bool | BeginWrite3dmFontTable ()
bool | Write3dmFont (const ON_Font &)
bool | EndWrite3dmFontTable ()
bool | BeginRead3dmFontTable ()
int | Read3dmFont (ON_Font **)
bool | EndRead3dmFontTable ()
bool | BeginWrite3dmDimStyleTable ()
bool | Write3dmDimStyle (const ON_DimStyle &)
bool | EndWrite3dmDimStyleTable ()
bool | BeginRead3dmDimStyleTable ()
int | Read3dmDimStyle (ON_DimStyle **)
bool | EndRead3dmDimStyleTable ()
bool | BeginWrite3dmLightTable ()
bool | Write3dmLight (const ON_Light &, const ON_3dmObjectAttributes *)
bool | EndWrite3dmLightTable ()
bool | BeginRead3dmLightTable ()
int | Read3dmLight (ON_Light **, ON_3dmObjectAttributes *)
bool | EndRead3dmLightTable ()
bool | BeginWrite3dmHatchPatternTable ()
bool | Write3dmHatchPattern (const ON_HatchPattern &)
bool | EndWrite3dmHatchPatternTable ()
bool | BeginRead3dmHatchPatternTable ()
int | Read3dmHatchPattern (ON_HatchPattern **)
bool | EndRead3dmHatchPatternTable ()
bool | BeginWrite3dmInstanceDefinitionTable ()
bool | Write3dmInstanceDefinition (const ON_InstanceDefinition &)
bool | EndWrite3dmInstanceDefinitionTable ()
bool | BeginRead3dmInstanceDefinitionTable ()
int | Read3dmInstanceDefinition (ON_InstanceDefinition **)
bool | EndRead3dmInstanceDefinitionTable ()
bool | BeginWrite3dmObjectTable ()
bool | Write3dmObject (const ON_Object &, const ON_3dmObjectAttributes *)
bool | EndWrite3dmObjectTable ()
bool | BeginRead3dmObjectTable ()
int | Read3dmObject (ON_Object **, ON_3dmObjectAttributes *, unsigned int=0)
bool | EndRead3dmObjectTable ()
bool | BeginWrite3dmHistoryRecordTable ()
bool | Write3dmHistoryRecord (const class ON_HistoryRecord &)
bool | EndWrite3dmHistoryRecordTable ()
bool | BeginRead3dmHistoryRecordTable ()
int | Read3dmHistoryRecord (class ON_HistoryRecord *&)
bool | EndRead3dmHistoryRecordTable ()
bool | BeginWrite3dmUserTable (const ON_UUID &plugin_id, bool bSavingGoo, int goo_3dm_version, int goo_opennurbs_version)
bool | EndWrite3dmUserTable ()
bool | Write3dmAnonymousUserTableRecord (const ON_UUID &plugin_id, int goo_3dm_version, int goo_opennurbs_version, const ON_3dmGoo &goo)
ON_DEPRECATED bool | BeginWrite3dmUserTable (const ON_UUID &)
ON_DEPRECATED bool | Write3dmAnonymousUserTable (const ON_3dmGoo &)
bool | BeginRead3dmUserTable (ON_UUID &plugin_id, bool *bLastSavedAsGoo, int *archive_3dm_version, int *archive_opennurbs_version)
bool | Read3dmAnonymousUserTable (int archive_3dm_version, int archive_opennurbs_version, ON_3dmGoo &goo)
bool | EndRead3dmUserTable ()
ON_DEPRECATED bool | BeginRead3dmUserTable (ON_UUID &)
ON_DEPRECATED bool | Read3dmAnonymousUserTable (ON_3dmGoo &)
bool | Write3dmEndMark ()
bool | Read3dmEndMark (size_t *)
bool | BeginWrite3dmChunk (unsigned int, int)
bool | BeginWrite3dmBigChunk (ON__UINT32 typecode, ON__INT64 value)
bool | BeginWrite3dmChunk (unsigned int tcode, int major_version, int minor_version)
bool | EndWrite3dmChunk ()
bool | Write3dmGoo (const ON_3dmGoo &)
ON_DEPRECATED bool | BeginRead3dmChunk (unsigned int *, int *)
bool | BeginRead3dmBigChunk (unsigned int *, ON__INT64 *)
bool | BeginRead3dmChunk (unsigned int expected_tcode, int *major_version, int *minor_version)
bool | EndRead3dmChunk ()
bool | EndRead3dmChunk (bool bSupressPartiallyReadChunkWarning)
bool | BeginWriteDictionary (ON_UUID dictionary_id, unsigned int version, const wchar_t *dictionary_name)
bool | EndWriteDictionary ()
bool | BeginWriteDictionaryEntry (int de_type, const wchar_t *entry_name)
bool | EndWriteDictionaryEntry ()
bool | BeginReadDictionary (ON_UUID *dictionary_id, unsigned int *version, ON_wString &dictionary_name)
bool | EndReadDictionary ()
int | BeginReadDictionaryEntry (int *de_type, ON_wString &entry_name)
bool | EndReadDictionaryEntry ()
bool | Read3dmGoo (ON_3dmGoo &)
ON_DEPRECATED bool | PeekAt3dmChunkType (unsigned int *, int *)
bool | PeekAt3dmBigChunkType (ON__UINT32 *typecode, ON__INT64 *big_value)
bool | Seek3dmChunkFromStart (unsigned int)
bool | Seek3dmChunkFromCurrentPosition (unsigned int)
bool | Write3dmChunkVersion (int, int)
bool | Read3dmChunkVersion (int *, int *)
bool | WriteObjectUserData (const ON_Object &object)
bool | ReadObjectUserData (ON_Object &object)
int | Archive3dmVersion () const
int | ArchiveOpenNURBSVersion () const
size_t | ArchiveStartOffset () const
int | GetCurrentChunk (ON_3DM_CHUNK &chunk) const
int | GetCurrentChunk (ON_3DM_BIG_CHUNK &big_chunk) const
bool | FindTableInDamagedArchive (unsigned int tcode_table, unsigned int tcode_record, ON_UUID class_uuid, int min_length_data)
unsigned int | Dump3dmChunk (ON_TextLog &text_log, int recursion_depth=0)
bool | ReadV1_TCODE_RH_POINT (ON_Object **, ON_3dmObjectAttributes *)
bool | ReadV1_TCODE_MESH_OBJECT (ON_Object **, ON_3dmObjectAttributes *)
bool | ReadV1_TCODE_LEGACY_CRV (ON_Object **, ON_3dmObjectAttributes *)
bool | ReadV1_TCODE_LEGACY_FAC (ON_Object **, ON_3dmObjectAttributes *)
bool | ReadV1_TCODE_LEGACY_SHL (ON_Object **, ON_3dmObjectAttributes *)
bool | ReadV1_TCODE_RHINOIO_OBJECT_NURBS_CURVE (ON_Object **, ON_3dmObjectAttributes *)
bool | ReadV1_TCODE_RHINOIO_OBJECT_NURBS_SURFACE (ON_Object **, ON_3dmObjectAttributes *)
bool | ReadV1_TCODE_RHINOIO_OBJECT_BREP (ON_Object **, ON_3dmObjectAttributes *)
bool | ReadV1_TCODE_ANNOTATION (unsigned int, ON_Object **, ON_3dmObjectAttributes *)
size_t | SizeofChunkLength () const

## Protected Member Functions

size_t | Read (size_t, void *)
size_t | Write (size_t, const void *)
bool | Flush ()
Protected Member Functions inherited from ON_BinaryArchive
virtual int | LoadUserDataApplication (ON_UUID application_id)
bool | SetArchive3dmVersion (int)
unsigned int | ErrorMessageMask () const
bool | MaskReadError (ON__UINT64 sizeof_request, ON__UINT64 sizeof_read) const

## Additional Inherited Members

Public Types inherited from ON_BinaryArchive
enum | table_type { no_active_table = 0, properties_table, settings_table, bitmap_table, texture_mapping_table, material_table, linetype_table, layer_table, light_table, object_table, group_table, font_table, dimstyle_table, hatchpattern_table, instance_definition_table, historyrecord_table, user_table }
Static Public Member Functions inherited from ON_BinaryArchive
static bool | ToggleByteOrder (int, int, const void *, void *)
static const char * | TypecodeName (unsigned int tcode)
static char * | ON_TypecodeParse (unsigned int tcode, char *typecode_name, size_t max_length)
static int | CurrentArchiveVersion ()

## Detailed Description

Definition at line 2819 of file opennurbs_archive.h.

## Constructor & Destructor Documentation

## ON_BinaryArchiveBuffer()

ON_BinaryArchiveBuffer::ON_BinaryArchiveBuffer | ( | ON::archive_mode | ,
|  | ON_Buffer * | buffer
| ) |  |

## ~ON_BinaryArchiveBuffer()

virtual ON_BinaryArchiveBuffer::~ON_BinaryArchiveBuffer | ( |  | ) |

virtual

## Member Function Documentation

## AtEnd()

bool ON_BinaryArchiveBuffer::AtEnd | ( |  | ) | const

virtual

Implements ON_BinaryArchive.

## Buffer()

ON_Buffer* ON_BinaryArchiveBuffer::Buffer | ( |  | ) | const

## CurrentPosition()

size_t ON_BinaryArchiveBuffer::CurrentPosition | ( |  | ) | const

virtual

Implements ON_BinaryArchive.

## Flush()

bool ON_BinaryArchiveBuffer::Flush | ( |  | ) |

protected virtual

Implements ON_BinaryArchive.

## Read()

size_t ON_BinaryArchiveBuffer::Read | ( | size_t | ,
|  | void * |
| ) |  |

protected virtual

Implements ON_BinaryArchive.

## SeekFromCurrentPosition()

bool ON_BinaryArchiveBuffer::SeekFromCurrentPosition | ( | int |  | ) |

virtual

Implements ON_BinaryArchive.

## SeekFromEnd()

bool ON_BinaryArchiveBuffer::SeekFromEnd | ( | ON__INT64 |  | ) |

## SeekFromStart()

bool ON_BinaryArchiveBuffer::SeekFromStart | ( | size_t |  | ) |

virtual

Implements ON_BinaryArchive.

## SetBuffer()

bool ON_BinaryArchiveBuffer::SetBuffer | ( | ON_Buffer * | buffer | ) |

## Write()

size_t ON_BinaryArchiveBuffer::Write | ( | size_t | ,
|  | const void * |
| ) |  |

protected virtual

Implements ON_BinaryArchive.

The documentation for this class was generated from the following file:

- /build/pcl-OilVEB/pcl-1.8.1+dfsg1/surface/include/pcl/surface/3rdparty/opennurbs/opennurbs_archive.h